//////////////////////////////////////////////////
// 10/06/2021 => Premier test sur Arduino MEGA, avec souris PS2, ça fonctionne
//            => pas encore réussi à mettre les textes dans une bibliothèque
//            => jeux Marauder + appli DRAW
//
// 11/06/2021 => intégration de la fonction de lecture de txt sur carte SD (y a t'il besoin du délais de 5s?)
//            => application d'ecriture vortexte (rajouter option pour double taille?)
//            BUG à corriger=> certaines zones cliquables d'icones restent actives dans les applications (readSD)
//            BUG => quand on revient au sommaire, le bouton readSD ne marche plus : corrigé 18.06.2021
//            A AJOUTER facilement = une page GUIDE avec les touches de raccourci expliquée
//
// 14/06/2021 => MARAUDER = désormais le monstre poursuit le héro
//               il faudrait rétrécir le terrain de jeux pour augmenter la difficulté
//               le terrain pourrait rétrécir au fur et a mesure des victoires.
// 18/06/2021 => bug des zones cliquables résolu
//            => intégration dans le boitier avec carte relais et lecteur de cartouche : OK
//            => le lecteur de carte SD à encore cramé sans raison, peut-être faut-il l'alimenter en 5v au lieu de 3.3v
//            => test de passage en mode mixte/teleinformatique, la souris marche, le texte aussi mais avec des bugs.
//            => note = les touches de direction fonctionnent en mode mixte/tele
// 19/06/2021 => limitation de la zone de jeux dans Maraudeur
//            => pas réussi à coder les flèches de direction, /!\ demander à E.Serandour? /!\
//            => test du mode graphique
//
// 21/06/2021 => message apparaissant dans le menu quand la souris passe dessus.
//            => page GUIDE
//            => embryon de moniteur série mais échec. Il faudrait passer le minitel sur RX1/TX1, mais je n'ai pas réussi à le faire
//               pour une raison qui m'échappe. /!\ demander à E.Serandour? /!\
//////////////////////////////////////////////////

#include <Arduino.h>
// on ajoute la librairie qui va gérer le minitel
#include <Zardos-Minitel1B_Hard.h>
// bibliothèque pour mettre des messages en mémoire flash
//#include <avr/pgmspace.h> 

#include <SD.h>

// on déclare la variable qui va nous permettre de jouer avec le Minitel
// on indique sur quel port série la connexion est faite, ici Serial
Minitel minitel(Serial);

//////////////////////////////
// test cartouche
/////////////////////////////

//const int cart_ground =  11; 
//const int cart_Tx =  10;
//const int cart_Rx =  9;
//const int l;                                                                                                                                                                                                                                                                                                                                                                                                     ddd, =  8;

//////////////////////////////////////////
//    Messages à afficher à l'écran
////////////////////////////////////////
String zardoz1msg("Minitel Zard-OS 1.0");
String zardoz2msg("pour plus d'info");
String zardoz3msg("appuyez sur");
String zardoz4msg(" [GUIDE]  ");
String scrollmsg(">mode rouleau");
String credit0msg("Lomig Perrotin : 18.06.2021");
String credit1msg("Minitel Librairies:Eric Serandour");
String credit2msg("http://3615.entropie.org");
String credit3msg("Mouse Code : Waseem Abbas");
String credit4msg("Engr.waseemabbas@yahoo.com");
String comspeedmsg(">Communication : 1200 bauds");
String echo1msg(">echo ON");
String echo2msg(">echo OFF");
String readSDmsg("READ");
String loadcartmsg("CART.");
String vortextemsg("TEXTE");
String drawmsg("DRAW");
String test1msg("test");
String serial1msg("=>");
String serial2msg("<=");
String gamesmsg("GAMES");
String graphzard0msg("     .<xxxx>.  ");
String graphzard1msg("    .<xxxxxx>.");
String graphzard2msg("   .<x  ##  x>.");
String graphzard3msg("  .<x @ xx @ x>.");
String graphzard4msg(" .<xxx_x][x_xxx>.");
String graphzard5msg(" .<xxxxx][xxxxx>.");
String graphzard5bismsg(" .<x###_UU_###x>.");
String graphzard6msg(".<x#z        z#x>.");
String graphzard7msg(".<#z   ,,,,   z#>.");
String graphzard8msg(" .<x,,,xxxx,,,x>.");
String graphzard9msg("  .<xxxxxxxxxx>.");



void setup() {
  // configuration des commandes du relais
  pinMode(minitel.cart_ground, OUTPUT);
  pinMode(minitel.cart_Tx, OUTPUT);
  pinMode(minitel.cart_Rx, OUTPUT);
  pinMode(minitel.cart_Vin, OUTPUT);
  //
  Serial.begin(1200);
  // on cherche le Minitel et on récupère la vitesse de communication
  int speed = minitel.searchSpeed();
  minitel.bip();
  bootScreen();
  delay(500);
  OS_menu();
  SD.begin(53);
  minitel.mouse_init();
     
}

void loop() {
  //char k = Serial.read();
  minitel.mouse();  // mouvement de la souris
  //minitel.keyboard(); // interrogation du clavier
  clavier();
  //if((Serial.available()) && (minitel.seria_l == true)){
  //minitel.keyboard();}
  //if((Serial.available()) && (minitel.seria_l == true)){
  //minitel.print(Serial.available);}
  if (minitel.maraude_r == true){
    minitel.marauder_move();}
}
/////////////////////////////////////////
//      ecran de démarrage
///////////////////////////////////////
void bootScreen(){
  minitel.noCursor();
  minitel.newScreen();
  minitel.smallMode();
  minitel.rect(3, 2, 39, 20);
  minitel.moveCursorXY(4, 4);
  minitel.attributs(DOUBLE_HAUTEUR);
  minitel.print(zardoz1msg);
  minitel.moveCursorXY(11, 6);
  minitel.attributs(GRANDEUR_NORMALE);
  minitel.print(credit0msg);
  minitel.hLine(4, 7, 38, CENTER);
  minitel.moveCursorXY(4, 9);
  minitel.print(credit1msg);
  minitel.moveCursorXY(15, 10);
  minitel.print(credit2msg);
  minitel.moveCursorXY(4, 12);
  minitel.print(credit3msg);
  minitel.moveCursorXY(13, 13);
  minitel.print(credit4msg);
  minitel.moveCursorXY(4, 15);
  minitel.print(comspeedmsg);
  minitel.moveCursorXY(4, 16);  
  minitel.print(echo1msg);
  minitel.moveCursorXY(4, 17);
  minitel.print(scrollmsg);
  minitel.moveCursorXY(4, 18);
}
/////////////////////////////////////////
//      ecran de Menu
///////////////////////////////////////
void OS_menu(){  
  minitel.newScreen();
  minitel.bool_box(); // a remplacer par une fonction qui remet tout à false
  minitel.rect(3, 1, 10, 7);
  minitel.moveCursorXY(4, 4);
  minitel.print(readSDmsg);
  minitel.rect(31, 1, 38, 7);
  minitel.moveCursorXY(32, 4);
  minitel.print(vortextemsg);
  minitel.rect(3, 8, 10, 14);
  minitel.moveCursorXY(4, 11);
  minitel.print(loadcartmsg);
  minitel.rect(31, 8, 38, 14);
  minitel.moveCursorXY(32, 11);
  minitel.print(drawmsg);
  minitel.rect(3, 15, 10, 22);
  minitel.moveCursorXY(5, 18);
  minitel.print(serial1msg);
  minitel.moveCursorXY(6, 19);
  minitel.print(serial2msg);
  minitel.rect(31, 15, 38, 22);
  minitel.moveCursorXY(32, 19);
  minitel.print(gamesmsg);
  minitel.rect(12, 15, 29, 22);
  minitel.moveCursorXY(12, 2);
  minitel.attributs(DOUBLE_HAUTEUR);
  minitel.print(zardoz1msg);
  minitel.attributs(GRANDEUR_NORMALE);
  minitel.moveCursorXY(12, 4);
  minitel.print(graphzard0msg);
  minitel.moveCursorXY(12, 5);
  minitel.print(graphzard1msg);
  minitel.moveCursorXY(12, 6);
  minitel.print(graphzard2msg);
  minitel.moveCursorXY(12, 7);
  minitel.print(graphzard3msg);
  minitel.moveCursorXY(12, 8);
  minitel.print(graphzard4msg);
  minitel.moveCursorXY(12, 9);
  minitel.print(graphzard5msg);
  minitel.moveCursorXY(12, 10);
  minitel.print(graphzard5bismsg);
  minitel.moveCursorXY(12, 11);
  minitel.print(graphzard6msg);
  minitel.moveCursorXY(12, 12);
  minitel.print(graphzard7msg);
  minitel.moveCursorXY(12, 13);
  minitel.print(graphzard8msg);
  minitel.moveCursorXY(12, 14);
  minitel.print(graphzard9msg);
  minitel.moveCursorXY(13, 17);
  minitel.print(zardoz2msg);
  minitel.moveCursorXY(13, 18);
  minitel.print(zardoz3msg);
  minitel.moveCursorXY(13, 19);
  minitel.print(zardoz4msg);
  minitel.cursor();
  minitel.moveCursorXY(20, 12);
  minitel.mouse_init();
}


void clavier(){
unsigned long key = minitel.getKeyCode();
    
 if (key != 0) // une touche a été pressée
  { 
     if (key == key_A)
     minitel.c = (65);
     if (key == key_B)
     minitel.c = (char (66));
     if (key == key_C)
     minitel.c = (char (67));
     if (key == key_D)
     minitel.c = (char (68));
     if (key == key_E)
     minitel.c = (char (69));
     if (key == key_F)
     minitel.c = (char (70));
     if (key == key_G)
     minitel.c = (char (71));
     if (key == key_H)
     minitel.c = (char (72));
     if (key == key_I)
     minitel.c = (char (73));
     if (key == key_J)
     minitel.c = (char (74));
     if (key == key_K)
     minitel.c = (char (75));
     if (key == key_L)
     minitel.c = (char (76));
     if (key == key_M)
     minitel.c = (char (77));
     if (key == key_N)
     minitel.c = (char (78));
     if (key == key_O)
     minitel.c = (char (79));
     if (key == key_P)
     minitel.c = (char (80));
     if (key == key_Q)
     minitel.c = (char (81));
     if (key == key_R)
     minitel.c = (char (82));
     if (key == key_S)
     minitel.c = (char (83));
     if (key == key_T)
     minitel.c = (char (84));
     if (key == key_U)
     minitel.c = (char (85));
     if (key == key_V)
     minitel.c = (char (86));
     if (key == key_W)
     minitel.c = (char (87));
     if (key == key_X)
     minitel.c = (char (88));
     if (key == key_Y)
     minitel.c = (char (89));
     if (key == key_Z)
     minitel.c = (char (90));
     if (key == key_EXCLAM)
     minitel.c = (char (33));
     if (key == key_QUOTE)
     minitel.c = (char (34));
     if (key == key_HASH)
     minitel.c = (char (35));
     if (key == key_DOLLAR)
     minitel.c = (char (36));
     if (key == key_PERCENT)
     minitel.c = (char (37));
     if (key == key_AND)
     minitel.c = (char (38));
     if (key == key_AP)
     minitel.c = (char (39));
     if (key == key_par_o)
     minitel.c = (char (40));
     if (key == key_par_c)
     minitel.c = (char (41));
     if (key == key_STAR)
     minitel.c = (char (42));
     if (key == key_PLUS)
     minitel.c = (char (43));
     if (key == key_VIRG)
     minitel.c = (char (44));
     if (key == key_MOINS)
     minitel.c = (char (45));
     if (key == key_DOT)
     minitel.c = (char (46));
     if (key == key_SLASH)
     minitel.c = (char (47));
     if (key == key_0)
     minitel.c = (char (48));
     if (key == key_1)
     minitel.c = (49);
     if (key == key_2)
     minitel.c = (char (50));
     if (key == key_3)
     minitel.c = (char (51));
     if (key == key_4)
     minitel.c = (char (52));
     if (key == key_5)
     minitel.c = (char (53));
     if (key == key_6)
     minitel.c = (char (54));
     if (key == key_7)
     minitel.c = (char (55));
     if (key == key_8)
     minitel.c = (char (56));
     if (key == key_9)
     minitel.c = (char (57));
     if (key == key_2P)
     minitel.c = (char (58));
     if (key == key_PV)
     minitel.c = (char (59));
     if (key == key_INF_A)
     minitel.c = (char (60));
     if (key == key_EGAL)
     minitel.c = (char (61));
     if (key == key_SUP_A)
     minitel.c = (char (62));
     if (key == key_QUESTION)
     minitel.c = (char (63));
     if (key == ENVOI)
     minitel.c = (char (13));
     if (key == RETOUR)
     minitel.c = (char (13));
     if (key == SP)
     minitel.c = (char (32));
     if (key == DEL)
     minitel.c = (char (127));
     if (key == FLECHE_GAUCHE)
     minitel.moveCursorLeft(1);
     if (key == FLECHE_DROITE)
     minitel.moveCursorRight(1);
     if (key == FLECHE_HAUT)
     minitel.moveCursorUp(1);
     if (key == FLECHE_BAS)
     minitel.moveCursorDown(1);
     // Touches de fonction a définir
     //if (key == REPETITION)
     if (key == GUIDE)
     minitel.guide();
     if (key == ANNULATION)
     minitel.pushReset();
     if (key == SOMMAIRE)
     OS_menu();
     //if (minitel.seria_l == true){ Serial.print(minitel.c);}
     //if (key == BS)
     //c = (char (0x08));
  // essai de backspace, fonctionne mais n'efface pas le caractère réellement tapé dans BASIC
     //if (key == SUITE)
     //if (key == CONNEXION)
  }
  if ((minitel.vortext_e == true) && (key == ENVOI)){ 
    minitel.println("");}
    if ((minitel.seria_l == true) && (key == ENVOI)){ 
    Serial.println("test communication");}
  
  if ((minitel.dra_w == true) && (key != 0)){
     minitel.moveCursorXY(30, 24);
     minitel.print("[ ");
     minitel.printChar(minitel.c);
     minitel.print(" ]");
     minitel.moveCursorXY(minitel.xCursor, minitel.yCursor);}
  if ((minitel.maraude_r == true) && (key == REPETITION)){ // mouvement à droite
     minitel.moveCursorXY(minitel.marauder_heroX , minitel.marauder_heroY);
     minitel.deleteChars(1);
     minitel.marauder_heroX = (minitel.marauder_heroX+1);
     minitel.marauder_heroX = constrain(minitel.marauder_heroX, 13, 27);
     minitel.moveCursorXY(minitel.marauder_heroX , minitel.marauder_heroY);
     minitel.print("0");}
  if ((minitel.maraude_r == true) && (key == RETOUR)){  // mouvement à gauche
     minitel.moveCursorXY(minitel.marauder_heroX , minitel.marauder_heroY);
     minitel.deleteChars(1);
     minitel.marauder_heroX = (minitel.marauder_heroX-1);
     minitel.marauder_heroX = constrain(minitel.marauder_heroX, 13, 27);
     minitel.moveCursorXY(minitel.marauder_heroX , minitel.marauder_heroY);
     minitel.print("0");}
  if ((minitel.maraude_r == true) && (key == ENVOI)){  // mouvement à gauche
     minitel.marauder_sabreY = (minitel.marauder_heroY-1);
     minitel.marauder_sabreX = (minitel.marauder_heroX);
     minitel.moveCursorXY(minitel.marauder_sabreX , minitel.marauder_sabreY);
     minitel.print("/");
     if ((minitel.marauder_monsterX == minitel.marauder_sabreX  ) && (minitel.marauder_monsterY == minitel.marauder_sabreY)){
     minitel.marauder_win();}
     minitel.moveCursorXY(minitel.marauder_sabreX , minitel.marauder_sabreY);
     minitel.deleteChars(1);
     //minitel.marauder_sabreY = 0;
     
    /* 
     minitel.deleteChars(1);
     minitel.marauder_sabreY = 0;*/
     //delay(100);
     //marauder_sabre = false;
     }
}
